﻿///
/// Windows プラットフォーム用共通ヘッダファイル。
///

#if       !defined(INCLUDED_SZ_WINDOWS)
#define            INCLUDED_SZ_WINDOWS

SZ_NS_BEG(szpp)

/// <summary>
/// SevenZip++ のクライアントの起動時に呼び出す初期化関数。
/// </summary>
/// <param name="hModule">クライアントのモジュールハンドル。EXE クライアントの場合は GetModuleHandle(0) を渡せばよい。</param>
/// <remarks>
/// 7-Zip コーデック DLL のロードに先だって設定しておく必要がある。
/// </remarks>
SZ_SPEC
void OnClientStartup(HMODULE hModule);

/// <summary>
/// SevenZip++ のクライアントの終了時に呼び出す初期化関数。
/// </summary>
SZ_SPEC
void OnClientShutdown();

/// <summary>
/// OnClientStartup で指定したモジュールのファイルパスを取得する関数。
/// </summary>
SZ_SPEC
szstring GetClientModuleFileName();

SZ_NS_END(szpp)

#endif // !defined(INCLUDED_SZ_WINDOWS)
